## faketime 0.9.1

=== Makefile ===
all:
	$(MAKE) -C src all
	$(MAKE) -C test all

test:
	$(MAKE) -C test all

install:
	$(MAKE) -C src install
	$(MAKE) -C man install
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}/share/doc/faketime/"
	$(INSTALL) -m0644 README "${DESTDIR}${PREFIX}/share/doc/faketime/README"
	$(INSTALL) -m0644 NEWS "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"

uninstall:
	$(MAKE) -C src uninstall
	$(MAKE) -C man uninstall
	rm -f "${DESTDIR}${PREFIX}/share/doc/faketime/README"
	rm -f "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"
	rmdir "${DESTDIR}${PREFIX}/share/doc/faketime"

clean:
	$(MAKE) -C src clean
	$(MAKE) -C test clean

distclean:
	$(MAKE) -C src distclean
	$(MAKE) -C test distclean

.PHONY: all test install uninstall clean distclean

=== man/Makefile ===
INSTALL = install

PREFIX = /usr/local

all:

install:
	$(INSTALL) -Dm0644 faketime.1 "${DESTDIR}${PREFIX}/share/man/man1/faketime.1"
	gzip -f "${DESTDIR}${PREFIX}/share/man/man1/faketime.1"

uninstall:
	rm -f "${DESTDIR}${PREFIX}/share/man/man1/faketime.1.gz"

.PHONY: all install uninstall

=== src/Makefile ===
#
# Notes:
#
#   * Compilation Defines:
#
#     FAKE_STAT
#         - Enables time faking also for files' timestamps. 
#
#     NO_ATFILE
#         - Disables support for the fstatat() group of functions
#     
#     PTHREAD
#         - Define this to enable multithreading support.
#
#     PTHREAD_SINGLETHREADED_TIME
#         - Define this if you want to single-thread time() ... there ARE
#           possibile caching side-effects in a multithreaded environment
#           without this, but the performance impact may require you to
#           try it unsynchronized.
#
#     FAKE_INTERNAL_CALLS
#         - Also intercept libc internal __functions, e.g. not just time(), 
#           but also __time(). Enhances compatibility with applications
#           that make use of low-level system calls, such as Java Virtual
#           Machines.       
#
#     NO_CACHING
#         - Disables the caching of the fake time offset. Only disable caching
#           if you change the fake time offset during program runtime very 
#           frequently. Disabling the cache may negatively influence the
#           performance. 
#
#     LIMITEDFAKING
#		  - Support environment variables that limit time faking to certain
#		    time intervals or number of function calls.
#
#     SPAWNSUPPORT
#         - Enable support for spawning an external process at a given
#           timestamp.
#
#   * Compilation addition: second libMT target added for building the pthread-
#     enabled library as a separate library
#
#   * Compilation switch change: previous versions compiled using '-nostartfiles'
#     This is no longer the case since there is a 'startup' constructor for the library
#     which is used to activate the start-at times when specified. This also initializes
#     the dynamic disabling of the FAKE_STAT calls.
#

CC = gcc
INSTALL = install

PREFIX = /usr/local

CFLAGS += -std=gnu99 -Wall -DFAKE_STAT -DFAKE_INTERNAL_CALLS -fPIC -DPOSIX_REALTIME -DLIMITEDFAKING -DSPAWNSUPPORT
LDFLAGS += -shared -ldl -lm -lpthread

SRC = faketime.c
OBJ = faketime.o faketimeMT.o

SONAME = 1
LIBS = libfaketime.so.${SONAME} libfaketimeMT.so.${SONAME}

all: ${LIBS}

faketimeMT.o: EXTRA_FLAGS := -DPTHREAD -DPTHREAD_SINGLETHREADED_TIME

${OBJ}: faketime.c
	${CC} -o $@ -c ${CFLAGS} ${EXTRA_FLAGS} $<

lib%.so.${SONAME}: %.o
	${CC} -o $@ -Wl,-soname,$@ ${LDFLAGS} $<

clean: 
	@rm -f ${OBJ} ${LIBS}

distclean: clean
	@echo 

install: ${LIBS}
	@echo 
	@echo "Copying the faketime libraries to ${DESTDIR}${PREFIX}/lib/faketime and the faketime wrapper script to ${DESTDIR}${PREFIX}/bin ..."
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}/lib/faketime/"
	$(INSTALL) -m0644 ${LIBS} "${DESTDIR}${PREFIX}/lib/faketime/"
	$(INSTALL) -Dm0755 faketime "${DESTDIR}${PREFIX}/bin/faketime"

uninstall:
	for f in ${LIBS}; do rm -f "${DESTDIR}${PREFIX}/lib/faketime/$$f"; done
	rmdir "${DESTDIR}${PREFIX}/lib/faketime"
	rm -f "${DESTDIR}${PREFIX}/bin/faketime"

.PHONY: all clean distclean install uninstall

=== test/Makefile ===
CC = gcc

CFLAGS = -std=gnu99 -Wall -DFAKE_STAT
LDFLAGS = -lrt

SRC = timetest.c
OBJ = ${SRC:.c=.o}

all: timetest test

.c.o:
	${CC} -c ${CFLAGS} $<

timetest: ${OBJ}
	${CC} -o $@ ${OBJ} ${LDFLAGS}

test: timetest functest
	@echo
	@./test.sh

# run functional tests
functest:
	./testframe.sh functests

clean: 
	@rm -f ${OBJ} timetest

distclean: clean
	@echo 

.PHONY: all test clean distclean

=== debian/changelog ===
faketime (0.9.1-2ubuntu1) saucy; urgency=low

  * Merge from debian, remaining changes: 
    - as-needed.patch: Fix object/library link order for --as-needed.

 -- Oussama Bounaim <o.bounaim@gmail.com>  Fri, 12 Jul 2013 21:37:07 +0100

faketime (0.9.1-2) unstable; urgency=low

  * fix FTBFS on kFreeBSD (Closes: #712709) (Thanks, Petr Salinger)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 20 Jun 2013 09:28:46 -0400

faketime (0.9.1-1ubuntu1) saucy; urgency=low

  * as-needed.patch: Fix object/library link order for --as-needed.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 11 Jun 2013 07:45:48 -0600

faketime (0.9.1-1) unstable; urgency=low

  * New Upstream Release
  * Moved to source format 3.0 (quilt)
  * debhelper compat level 9
  * bumped Standards-Version to 3.9.3 (no changes needed)
  * fix failures against libc 2.17 (Closes: #699559) (thanks, Gerardo
    Malazdrewicz)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 03 Feb 2013 01:42:35 -0500

faketime (0.8-1) unstable; urgency=low

  * Initial release (Closes: #495630)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 26 Aug 2008 14:37:38 -0400

=== debian/control ===
Source: faketime
Section: utils
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.4
Homepage: http://www.code-wizards.com/projects/libfaketime/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/faketime.git
Vcs-Git: git://anonscm.debian.org/collab-maint/faketime.git

Package: faketime
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: report faked system time to programs
 The Fake Time Preload Library (FTPL, a.k.a. libfaketime) intercepts
 various system calls which programs use to retrieve the current date
 and time. It can then report faked dates and times (as specified by
 you, the user) to these programs. This means you can modify the
 system time a program sees without having to change the time
 system-wide. FTPL allows you to specify both absolute dates (e.g.,
 2004-01-01) and relative dates (e.g., 10 days ago).

=== debian/rules ===
#!/usr/bin/make -f

# Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
# Date: Tue, 26 Aug 2008 14:24:50 -0400

# make sure dh_makeshlibs does not modify post{inst,rm} scripts:
# (avoids lintian's postinst-has-useless-call-to-ldconfig)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

%:
	PREFIX=/usr dh $@

## faketime 0.9.5

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
+INSTALL ?= install
+
 all:
 	$(MAKE) -C src all
-	$(MAKE) -C test all
 
 test:
 	$(MAKE) -C test all

=== src/Makefile ===
#
# Notes:
#
#   * Compilation Defines:
#
#     FAKE_STAT
#         - Enables time faking also for files' timestamps.
#
#     NO_ATFILE
#         - Disables support for the fstatat() group of functions
#
#     PTHREAD
#         - Define this to enable multithreading support.
#
#     PTHREAD_SINGLETHREADED_TIME
#         - Define this if you want to single-thread time() ... there ARE
#           possibile caching side-effects in a multithreaded environment
#           without this, but the performance impact may require you to
#           try it unsynchronized.
#
#     FAKE_INTERNAL_CALLS
#         - Also intercept libc internal __functions, e.g. not just time(),
#           but also __time(). Enhances compatibility with applications
#           that make use of low-level system calls, such as Java Virtual
#           Machines.
#
# 	  FAKE_SLEEP
# 	      - Also intercept sleep(), nanosleep(), usleep(), alarm(), [p]poll()
#
#	  FAKE_TIMERS
#	      - Also intercept timer_settime() and timer_gettime()
#
#     NO_CACHING
#         - Disables the caching of the fake time offset. Only disable caching
#           if you change the fake time offset during program runtime very
#           frequently. Disabling the cache may negatively influence the
#           performance.
#
#	  MULTI_ARCH
#	  	  - If MULTI_ARCH is set, the faketime wrapper program will put a literal
#	  	    $LIB into the LD_PRELOAD environment variable it creates, which makes
#	  	    ld automatically choose the correct library version to use for the
#	  	    target binary. Use for Linux platforms with Multi-Arch support only!
#
#   * Compilation addition: second libMT target added for building the pthread-
#     enabled library as a separate library
#
#   * Compilation switch change: previous versions compiled using '-nostartfiles'
#     This is no longer the case since there is a 'startup' constructor for the library
#     which is used to activate the start-at times when specified. This also initializes
#     the dynamic disabling of the FAKE_STAT calls.
#
# By default, libfaketime will be compiled for your system's default architecture.
# To build 32-bit libraries and binaries, add -m32 to CFLAGS and LDFLAGS.
#
# Change PREFIX to where you want libfaketime (libraries and wrapper binary) installed.
# LIBDIRNAME is relative to PREFIX. The default is to install into $PREFIX/lib/faketime,
# but you can set LIBDIRNAME to, e.g., /lib64 if you want to install it elsewhere.
# LIBDIRNAME has been introduced to support MultiLib systems. Please do not change the 
# default value on MultiArch systems. 
#
# For testing in the current directory without installation, try make PREFIX= LIBDIRNAME='.'

CC ?= gcc
INSTALL ?= install

PREFIX ?= /usr/local
LIBDIRNAME ?= /lib/faketime

CFLAGS += -std=gnu99 -Wall -Wextra -Werror -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"'
LIB_LDFLAGS += -shared
LDFLAGS += -Wl,--version-script=libfaketime.map -lrt
LDADD += -ldl -lm -lpthread -lrt

SRC = libfaketime.c
LIBS_OBJ = libfaketime.o libfaketimeMT.o
BINS = faketime

SONAME = 1
LIBS = libfaketime.so.${SONAME} libfaketimeMT.so.${SONAME}

all: ${LIBS} ${BINS}

faketimeMT.o: EXTRA_FLAGS := -DPTHREAD -DPTHREAD_SINGLETHREADED_TIME

${LIBS_OBJ}: libfaketime.c
	${CC} -o $@ -c ${CFLAGS} ${EXTRA_FLAGS} $<

%.so.${SONAME}: %.o libfaketime.map
	${CC} -o $@ -Wl,-soname,$@ ${LDFLAGS} ${LIB_LDFLAGS} $< ${LDADD}

${BINS}: faketime.c
	${CC} -o $@ ${CFLAGS} ${EXTRA_FLAGS} $< ${LDFLAGS} ${LDADD}

clean:
	@rm -f ${LIBS_OBJ} ${LIBS} ${BINS}

distclean: clean
	@echo

install: ${LIBS} ${BINS}
	@echo
	@echo "Copying the faketime libraries to ${DESTDIR}${PREFIX}${LIBDIRNAME} and the faketime wrapper script to ${DESTDIR}${PREFIX}/bin ..."
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -m0644 ${LIBS} "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -Dm0755 faketime "${DESTDIR}${PREFIX}/bin/faketime"

uninstall:
	for f in ${LIBS}; do rm -f "${DESTDIR}${PREFIX}${LIBDIRNAME}/$$f"; done
	rmdir "${DESTDIR}${PREFIX}${LIBDIRNAME}"
	rm -f "${DESTDIR}${PREFIX}/bin/faketime"

.PHONY: all clean distclean install uninstall

=== debian/changelog ===
faketime (0.9.5-2) unstable; urgency=medium

  * avoid accidentally truncating LD_PRELOAD. Thanks, Antonio Terceiro
    (Closes: #743301)
  
 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 02 Apr 2014 09:45:49 -0400

faketime (0.9.5-1) unstable; urgency=low

  * new upstream release
  * dropped build system patches -- incorporated upstream
  * debian/copyright: make machine-readable
  * enabled use on multi-arch (Closes: #672376) though manual installation
    of non-native libfaketime packages is still necessary; see:
    https://wiki.debian.org/HelmutGrohne/MultiarchSpecChanges#A.60LD_PRELOAD.60

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 14 Oct 2013 19:30:40 -0400

## faketime 0.9.6

=== src/Makefile ===
--- 
+++ 
@@ -69,8 +69,9 @@
 
 CFLAGS += -std=gnu99 -Wall -Wextra -Werror -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"'
 LIB_LDFLAGS += -shared
-LDFLAGS += -Wl,--version-script=libfaketime.map -lrt
-LDADD += -ldl -lm -lpthread -lrt
+LDFLAGS += -Wl,--version-script=libfaketime.map -lpthread
+LDADD += -ldl -lm -lrt
+BIN_LDFLAGS += -lrt
 
 SRC = libfaketime.c
 LIBS_OBJ = libfaketime.o libfaketimeMT.o
@@ -90,7 +91,7 @@
 	${CC} -o $@ -Wl,-soname,$@ ${LDFLAGS} ${LIB_LDFLAGS} $< ${LDADD}
 
 ${BINS}: faketime.c
-	${CC} -o $@ ${CFLAGS} ${EXTRA_FLAGS} $< ${LDFLAGS} ${LDADD}
+	${CC} -o $@ ${CFLAGS} ${EXTRA_FLAGS} $< ${LDFLAGS} ${BIN_LDFLAGS}
 
 clean:
 	@rm -f ${LIBS_OBJ} ${LIBS} ${BINS}

=== debian/changelog ===
faketime (0.9.6-7) unstable; urgency=medium

  * added DEP-8 test (thanks, Jakub Wilk!) (Closes: #830588)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 13 Jul 2016 03:41:16 +0200

faketime (0.9.6-6) unstable; urgency=medium

  * Fix CFLAGS (Closes: #830510) Thanks, Sven Joachim and Jakub Wilk for
    catching this!

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 09 Jul 2016 00:12:07 +0200

faketime (0.9.6-5) unstable; urgency=medium

  * use -Wno-nonnull-compare for GCC 6 (Closes: #811610)
  * use ${misc:Pre-Depends} for multiarch-support,
    avoiding lintian pre-depends-directly-on-multiarch-support
  * bumped standards-version to 3.9.8 (no changes needed)
  * normalize Vcs-* fields
  * use "wrap-and-sort -as" for normalizing debian/ files

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 07 Jul 2016 13:27:29 -0400

faketime (0.9.6-4) unstable; urgency=medium

  * link to libfaketime's README from faketime's doc dir (thanks, Ximin
    Luo)
  * bump Standards-Version to 3.9.6 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 14 Feb 2015 19:36:04 -0500

faketime (0.9.6-3) unstable; urgency=medium

  * a better fix (approved by upstream to let a single package work with
    multiple versions of libc (Closes: #755104)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 05 Aug 2014 15:15:06 -0400

faketime (0.9.6-2) unstable; urgency=medium

  * note that this version does not work with libc6 < 2.17 due to
    the patch for #699559 (Closes: #753460)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 13 Jul 2014 20:23:53 -0400

faketime (0.9.6-1) unstable; urgency=medium

  * New Upstream Release (Closes: #750721, #737571)
  * bumped Standards-Version to 3.9.5 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 08 Jun 2014 21:29:30 -0400

=== debian/control ===
Source: faketime
Section: utils
Priority: extra
Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 debhelper (>= 9),
 dh-exec (>= 0.3)
Standards-Version: 3.9.8
Homepage: http://www.code-wizards.com/projects/libfaketime/
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/faketime.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/faketime.git

Package: faketime
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libfaketime (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: foreign
Description: report faked system time to programs
 The Fake Time Preload Library (FTPL, a.k.a. libfaketime) intercepts
 various system calls which programs use to retrieve the current date
 and time. It can then report faked dates and times (as specified by
 you, the user) to these programs. This means you can modify the
 system time a program sees without having to change the time
 system-wide. FTPL allows you to specify both absolute dates (e.g.,
 2004-01-01) and relative dates (e.g., 10 days ago).

Package: libfaketime
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: report faked system time to programs
 The Fake Time Preload Library (FTPL, a.k.a. libfaketime) intercepts
 various system calls which programs use to retrieve the current date
 and time. It can then report faked dates and times (as specified by
 you, the user) to these programs. This means you can modify the
 system time a program sees without having to change the time
 system-wide. FTPL allows you to specify both absolute dates (e.g.,
 2004-01-01) and relative dates (e.g., 10 days ago).

=== debian/rules ===
#!/usr/bin/make -f

# why -Wno-nonnull-compare:
# GCC 6 includes a warning for checking if a variable nonnull if it's
# been tagged that passing a NULL value creates undefined behavior.
# faketime triggers this in its stat wrapper, which itself should
# itself have undefined behavior around NULL pointers.  But this
# doesn't make sense for an LD_PRELOAD hack.
# 
# See https://bugs.debian.org/811610 for more details.
export DEB_CFLAGS_MAINT_APPEND=-DMULTI_ARCH -Wno-nonnull-compare

# make sure dh_makeshlibs does not modify post{inst,rm} scripts:
# (avoids lintian's postinst-has-useless-call-to-ldconfig)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_installchangelogs:
	dh_installchangelogs NEWS

%:
	PREFIX=/usr dh $@

## faketime 0.9.7

=== test/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CC = gcc
 
-CFLAGS = -std=gnu99 -Wall -DFAKE_STAT
+CFLAGS = -std=gnu99 -Wall -DFAKE_STAT -Werror -Wextra
 LDFLAGS = -lrt
 
 SRC = timetest.c
@@ -22,10 +22,10 @@
 functest:
 	./testframe.sh functests
 
-clean: 
+clean:
 	@rm -f ${OBJ} timetest
 
 distclean: clean
-	@echo 
+	@echo
 
 .PHONY: all test clean distclean

=== debian/changelog ===
faketime (0.9.7-3ubuntu1) focal; urgency=medium

  * Don't fail on deprecation warnings in the test suite. A test deliberately
    checks the behaviour of ftime, which is deprecated in glibc 2.31.

 -- William Grant <wgrant@ubuntu.com>  Mon, 06 Apr 2020 16:54:55 +1000

faketime (0.9.7-3) unstable; urgency=medium

  * Acknowledge NMU (thanks, Tobias!)
  * use cherry-picked upstream git commits for fxing FTBFS
  * Standards-Version: bump to 4.2.1 (no changes needed)
  * d/changelog: drop trailing whitespace

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 06 Oct 2018 20:00:03 -0400

faketime (0.9.7-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Cherry-Pick fixes for the FTBFS with gcc-8 from upstream git
    repository. (Closes: #897747)

 -- Tobias Frost <tobi@debian.org>  Sat, 29 Sep 2018 16:35:04 +0200

faketime (0.9.7-2) unstable; urgency=medium

  * git: convert branch naming to DEP-14
  * use correct gettimeofday() on alpha (Closes: #890813)
  * d/control: use Rules-Requires-Root: no
  * d/rules: enable hardening flags
  * use CPPFLAGS to fix hardening-no-fortify-functions

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 19 Feb 2018 14:07:10 -0800

faketime (0.9.7-1) unstable; urgency=medium

  * New upstream release (Closes: #780088)
  * remove extra word in debian/rules comment (Closes: #830581)
  * use github as upstream link; code-wizards.com is down
  * d/copyright: Format: use https version
  * use github for uscan as well
  * Priority: optional instead of extra
  * clarify descriptions of the two packages
  * updated git-buildpackage to use upstream git repo
  * drop patches applied upstream
  * pull bugfix from upstream

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 19 Feb 2018 14:07:06 -0800

=== debian/control ===
Source: faketime
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 debhelper (>= 11~),
 dh-exec (>= 0.3),
Standards-Version: 4.2.1
Homepage: https://github.com/wolfcw/libfaketime
Vcs-Browser: https://salsa.debian.org/debian/faketime
Vcs-Git: https://salsa.debian.org/debian/faketime.git
Rules-Requires-Root: no

Package: faketime
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libfaketime (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: Report faked system time to programs (command-line tool)
 The Fake Time Preload Library (FTPL, a.k.a. libfaketime) intercepts
 various system calls which programs use to retrieve the current date
 and time. It can then report faked dates and times (as specified by
 you, the user) to these programs. This means you can modify the
 system time a program sees without having to change the time
 system-wide. FTPL allows you to specify both absolute dates (e.g.,
 2004-01-01) and relative dates (e.g., 10 days ago).
 .
 This package contains a "faketime" binary that makes it easy to use
 the LD_PRELOAD library.

Package: libfaketime
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Report faked system time to programs (preload library)
 The Fake Time Preload Library (FTPL, a.k.a. libfaketime) intercepts
 various system calls which programs use to retrieve the current date
 and time. It can then report faked dates and times (as specified by
 you, the user) to these programs. This means you can modify the
 system time a program sees without having to change the time
 system-wide. FTPL allows you to specify both absolute dates (e.g.,
 2004-01-01) and relative dates (e.g., 10 days ago).
 .
 This package contains the LD_PRELOAD library for faketime.

=== debian/tests/control ===
Tests: smoketest
Depends: faketime

## faketime 0.9.8

=== Makefile ===
INSTALL ?= install

UNAME=$(shell uname)
SELECTOR:=$(shell if test "${UNAME}" = "Darwin" ; then echo "-f Makefile.OSX" ; fi)

all:
	$(MAKE) $(SELECTOR) -C src all

test:
	$(MAKE) $(SELECTOR) -C src all
	$(MAKE) $(SELECTOR) -C test all

install:
	$(MAKE) $(SELECTOR) -C src install
	$(MAKE) $(SELECTOR) -C man install
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}/share/doc/faketime/"
	$(INSTALL) -m0644 README "${DESTDIR}${PREFIX}/share/doc/faketime/README"
	$(INSTALL) -m0644 NEWS "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"

uninstall:
	$(MAKE) $(SELECTOR) -C src uninstall
	$(MAKE) $(SELECTOR) -C man uninstall
	rm -f "${DESTDIR}${PREFIX}/share/doc/faketime/README"
	rm -f "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"
	rmdir "${DESTDIR}${PREFIX}/share/doc/faketime"

clean:
	$(MAKE) $(SELECTOR) -C src clean
	$(MAKE) $(SELECTOR) -C test clean

distclean:
	$(MAKE) $(SELECTOR) -C src distclean
	$(MAKE) $(SELECTOR) -C test distclean

.PHONY: all test install uninstall clean distclean

=== src/Makefile ===
#
# Notes:
#
#   * Compilation Defines:
#
#     FAKE_STAT
#         - Enables time faking also for files' timestamps.
#
#     NO_ATFILE
#         - Disables support for the fstatat() group of functions
#
#     PTHREAD_SINGLETHREADED_TIME
#         - Define this if you want to single-thread time() ... there ARE
#           possible caching side-effects in a multithreaded environment
#           without this, but the performance impact may require you to
#           try it unsynchronized.
#
#     FAKE_INTERNAL_CALLS
#         - Also intercept libc internal __functions, e.g. not just time(),
#           but also __time(). Enhances compatibility with applications
#           that make use of low-level system calls, such as Java Virtual
#           Machines.
#
#     FAKE_SLEEP
#         - Also intercept sleep(), nanosleep(), usleep(), alarm(), [p]poll()
#
#     FAKE_TIMERS
#         - Also intercept timer_settime() and timer_gettime()
#
#     FAKE_PTHREAD
#         - Intercept pthread_cond_timedwait
#
#     FORCE_MONOTONIC_FIX
#         - If the test program hangs forever on
#                  " pthread_cond_timedwait: CLOCK_MONOTONIC test
#                    (Intentionally sleeping 1 second...)          "
#           then add -DFORCE_MONOTONIC_FIX to CFLAGS and recompile.
#           (This is a platform-specific issue we cannot handle at run-time.)
#
#     MULTI_ARCH
#  	  - If MULTI_ARCH is set, the faketime wrapper program will put a literal
#           $LIB into the LD_PRELOAD environment variable it creates, which makes
#           ld automatically choose the correct library version to use for the
#           target binary. Use for Linux platforms with Multi-Arch support only!
#
#   * Compilation addition: second libMT target added for building the pthread-
#     enabled library as a separate library
#
#   * Compilation switch change: previous versions compiled using '-nostartfiles'
#     This is no longer the case since there is a 'startup' constructor for the library
#     which is used to activate the start-at times when specified. This also initializes
#     the dynamic disabling of the FAKE_STAT calls.
#
# By default, libfaketime will be compiled for your system's default architecture.
# To build 32-bit libraries and binaries, add -m32 to CFLAGS and LDFLAGS.
#
# Change PREFIX to where you want libfaketime (libraries and wrapper binary) installed.
# LIBDIRNAME is relative to PREFIX. The default is to install into $PREFIX/lib/faketime,
# but you can set LIBDIRNAME to, e.g., /lib64 if you want to install it elsewhere.
# LIBDIRNAME has been introduced to support MultiLib systems. Please do not change the
# default value on MultiArch systems.
#
# For testing in the current directory without installation, try make PREFIX= LIBDIRNAME='.'

CC ?= gcc
INSTALL ?= install

PREFIX ?= /usr/local
LIBDIRNAME ?= /lib/faketime
PLATFORM ?=$(shell uname)

CFLAGS += -std=gnu99 -Wall -Wextra -Werror -Wno-nonnull-compare -DFAKE_PTHREAD -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"' $(FAKETIME_COMPILE_CFLAGS)
ifeq ($(PLATFORM),SunOS)
CFLAGS += -D__EXTENSIONS__ -D_XOPEN_SOURCE=600
endif

LIB_LDFLAGS += -shared

LDFLAGS += -lpthread
ifneq ($(PLATFORM),SunOS)
LDFLAGS += -Wl,--version-script=libfaketime.map
endif

LDADD += -ldl -lm -lrt
BIN_LDFLAGS += -lrt

SRC = libfaketime.c
LIBS_OBJ = libfaketime.o libfaketimeMT.o
BINS = faketime

SONAME = 1
LIBS = libfaketime.so.${SONAME} libfaketimeMT.so.${SONAME}

all: ${LIBS} ${BINS}

libfaketimeMT.o: EXTRA_FLAGS := -DPTHREAD_SINGLETHREADED_TIME

${LIBS_OBJ}: libfaketime.c
	${CC} -o $@ -c ${CFLAGS} ${CPPFLAGS} ${EXTRA_FLAGS} $<

%.so.${SONAME}: %.o libfaketime.map
	${CC} -o $@ -Wl,-soname,$@ ${LDFLAGS} ${LIB_LDFLAGS} $< ${LDADD}

${BINS}: faketime.c
	${CC} -o $@ ${CFLAGS} ${CPPFLAGS} ${EXTRA_FLAGS} $< ${LDFLAGS} ${BIN_LDFLAGS}

clean:
	@rm -f ${LIBS_OBJ} ${LIBS} ${BINS}

distclean: clean
	@echo

install: ${LIBS} ${BINS}
	@echo
	@echo "Copying the faketime libraries to ${DESTDIR}${PREFIX}${LIBDIRNAME} and the faketime wrapper script to ${DESTDIR}${PREFIX}/bin ..."
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -m0644 ${LIBS} "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -Dm0755 faketime "${DESTDIR}${PREFIX}/bin/faketime"

uninstall:
	for f in ${LIBS}; do rm -f "${DESTDIR}${PREFIX}${LIBDIRNAME}/$$f"; done
	rmdir "${DESTDIR}${PREFIX}${LIBDIRNAME}"
	rm -f "${DESTDIR}${PREFIX}/bin/faketime"

.PHONY: all clean distclean install uninstall

=== test/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CC = gcc
 
-CFLAGS = -std=gnu99 -Wall -DFAKE_STAT -Werror -Wextra
-LDFLAGS = -lrt
+CFLAGS = -std=gnu99 -Wall -DFAKE_STAT -Werror -Wextra $(FAKETIME_COMPILE_CFLAGS)
+LDFLAGS = -lrt -lpthread
 
 SRC = timetest.c
 OBJ = ${SRC:.c=.o}

=== debian/changelog ===
faketime (0.9.8-9) unstable; urgency=medium

  * apply FORCE_MONOTONIC_FIX on all Linux arches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 11 Feb 2021 18:16:54 -0500

faketime (0.9.8-8) unstable; urgency=medium

  * add FORCE_MONOTONIC_FIX to ia64 and alpha

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 09 Feb 2021 14:06:34 -0500

faketime (0.9.8-7) unstable; urgency=medium

  * set FORCE_PTHREAD_NONVER on x32

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 06 Feb 2021 11:06:23 -0500

faketime (0.9.8-6) unstable; urgency=medium

  * fix MONOTONIC hangs on x32 and sparc64

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 04 Feb 2021 10:37:41 -0500

faketime (0.9.8-5) unstable; urgency=medium

  * adopt upstream mechanism for tweaking/fixing MONOTONIC hangs

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 03 Feb 2021 20:48:14 -0500

faketime (0.9.8-4) unstable; urgency=medium

  * added upstream test suite to CI
  * Apply fixes to permanent hangs on the appropriate architectures

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 03 Feb 2021 17:37:41 -0500

faketime (0.9.8-3) unstable; urgency=medium

  * clean up DEB_CFLAGS_MAINT_APPEND
  * FORCE_MONOTONIC_FIX only on arches where it is known to be needed
    (this might cause timeout failures on other build daemons as we
    learn where else it is needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 03 Feb 2021 10:17:42 -0500

faketime (0.9.8-2) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.
  * fix embedded version number

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 02 Feb 2021 19:21:15 -0500

faketime (0.9.8-1) unstable; urgency=medium

  * New upstream release
  * use branchname debian/main for debian packaging
  * convert to dh 13
  * Standards-Version: bump to 4.5.1 (no changes needed)
  * drop patches (already upstream)
  * apply -DFORCE_MONOTONIC_FIX to avoid infinite hangs in test/timetest.c
  * juggle changelog locations (see #965349)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 02 Feb 2021 14:32:55 -0500

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,10 @@
 Source: faketime
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
- debhelper (>= 11~),
- dh-exec (>= 0.3),
-Standards-Version: 4.2.1
+ debhelper-compat (= 13),
+Standards-Version: 4.5.1
 Homepage: https://github.com/wolfcw/libfaketime
 Vcs-Browser: https://salsa.debian.org/debian/faketime
 Vcs-Git: https://salsa.debian.org/debian/faketime.git

=== debian/rules ===
#!/usr/bin/make -f

DEB_CFLAGS_MAINT_APPEND=-DMULTI_ARCH

# why -DFORCE_MONOTONIC_FIX and -DFORCE_PTHREAD_NONVER: see README and
# timetest.c and https://github.com/wolfcw/libfaketime/issues/287
ifneq (,$(filter $(DEB_HOST_ARCH_OS),linux))
DEB_CFLAGS_MAINT_APPEND += -DFORCE_MONOTONIC_FIX
endif

ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el riscv64 x32))
DEB_CFLAGS_MAINT_APPEND += -DFORCE_PTHREAD_NONVER
endif

export DEB_CFLAGS_MAINT_APPEND

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# make sure dh_makeshlibs does not modify post{inst,rm} scripts:
# (avoids lintian's postinst-has-useless-call-to-ldconfig)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_installchangelogs:
	dh_installchangelogs NEWS

%:
	PREFIX=/usr dh $@

=== debian/tests/control ===
Tests: smoketest
Depends:
 faketime,
Restrictions: superficial

Tests: upstream
Depends:
 build-essential,
 libfaketime,

## faketime 0.9.10

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 UNAME=$(shell uname)
 SELECTOR:=$(shell if test "${UNAME}" = "Darwin" ; then echo "-f Makefile.OSX" ; fi)
+PREFIX ?= /usr/local
 
 all:
 	$(MAKE) $(SELECTOR) -C src all

=== src/Makefile ===
--- 
+++ 
@@ -1,25 +1,10 @@
 #
 # Notes:
 #
-#   * Compilation Defines:
+#   * Compilation Defines that are set by default:
 #
 #     FAKE_STAT
-#         - Enables time faking also for files' timestamps.
-#
-#     NO_ATFILE
-#         - Disables support for the fstatat() group of functions
-#
-#     PTHREAD_SINGLETHREADED_TIME
-#         - Define this if you want to single-thread time() ... there ARE
-#           possible caching side-effects in a multithreaded environment
-#           without this, but the performance impact may require you to
-#           try it unsynchronized.
-#
-#     FAKE_INTERNAL_CALLS
-#         - Also intercept libc internal __functions, e.g. not just time(),
-#           but also __time(). Enhances compatibility with applications
-#           that make use of low-level system calls, such as Java Virtual
-#           Machines.
+#         - Enables time faking when reading files' timestamps.
 #
 #     FAKE_SLEEP
 #         - Also intercept sleep(), nanosleep(), usleep(), alarm(), [p]poll()
@@ -30,6 +15,58 @@
 #     FAKE_PTHREAD
 #         - Intercept pthread_cond_timedwait
 #
+#     FAKE_INTERNAL_CALLS
+#         - Also intercept libc internal __functions, e.g. not just time(),
+#           but also __time(). Enhances compatibility with applications
+#           that make use of low-level system calls, such as Java Virtual
+#           Machines.
+#
+#     PTHREAD_SINGLETHREADED_TIME (only set in libfaketimeMT.so)
+#         - Define this if you want to single-thread time() ... there ARE
+#           possible caching side-effects in a multithreaded environment
+#           without this, but the performance impact may require you to
+#           try it unsynchronized.
+#
+#   * Compilation Defines that are unset by default:
+#
+#     FAKE_FILE_TIMESTAMPS, FAKE_UTIME
+#         - Enables time faking for the utime* functions.  If enabled via
+#           FAKE_FILE_TIMESTAMPS, the faking is opt-in at runtime using
+#           with the FAKE_UTIME environment variable. If enabled via
+#           FAKE_UTIME, the faking is opt-out at runtime.
+#
+#     NO_ATFILE
+#         - Disables support for the fstatat() group of functions
+#
+#     FAKE_SETTIME
+#         - Intercept clock_settime(), settimeofday(), and adjtime()
+#
+#     FAKE_RANDOM
+#         - Intercept getrandom()
+#
+#     FAKE_PID
+#         - Intercept getpid()
+#
+#     INTERCEPT_SYSCALL
+#         - (On GNU/Linux only) intercept glibc's syscall() for known relevant syscalls.
+#           If enabled, this currently only works to divert the getrandom syscall.
+#
+#         - note that on unusual architectures, if INTERCEPT_SYSCALL is set, you may
+#           need to explicitly define variadic_promotion_t (e.g. by putting
+#           -Dvariadic_promotion_t=int into CFLAGS).  See src/faketime_common.h for
+#           more info.
+#
+#     FAKE_STATELESS
+#         - Remove support for any functionality that requires sharing state across
+#           threads of a process, or different processes. This decreases the risk of
+#           interference with a program's normal execution, at the cost of supporting
+#           fewer ways of specifying the time.
+#           Concretely, this currently:
+#           - disables PTHREAD_SINGLETHREADED_TIME, which can cause deadlocks in
+#             multithreaded programs that fork due to making clock_gettime not
+#             async-signal-safe
+#           - disables all shared-memory across processes
+#
 #     FORCE_MONOTONIC_FIX
 #         - If the test program hangs forever on
 #                  " pthread_cond_timedwait: CLOCK_MONOTONIC test
@@ -38,10 +75,14 @@
 #           (This is a platform-specific issue we cannot handle at run-time.)
 #
 #     MULTI_ARCH
-#  	  - If MULTI_ARCH is set, the faketime wrapper program will put a literal
+#         - If MULTI_ARCH is set, the faketime wrapper program will put a literal
 #           $LIB into the LD_PRELOAD environment variable it creates, which makes
 #           ld automatically choose the correct library version to use for the
 #           target binary. Use for Linux platforms with Multi-Arch support only!
+#
+#     SILENT
+#         - avoid that the faketime wrapper complains when running within a
+#           libfaketime environment
 #
 #   * Compilation addition: second libMT target added for building the pthread-
 #     enabled library as a separate library
@@ -69,14 +110,14 @@
 LIBDIRNAME ?= /lib/faketime
 PLATFORM ?=$(shell uname)
 
-CFLAGS += -std=gnu99 -Wall -Wextra -Werror -Wno-nonnull-compare -DFAKE_PTHREAD -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"' $(FAKETIME_COMPILE_CFLAGS)
+CFLAGS += -std=gnu99 -Wall -Wextra -Werror -Wno-nonnull-compare -DFAKE_PTHREAD -DFAKE_STAT -DFAKE_UTIME -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"' $(FAKETIME_COMPILE_CFLAGS)
 ifeq ($(PLATFORM),SunOS)
 CFLAGS += -D__EXTENSIONS__ -D_XOPEN_SOURCE=600
 endif
 
 LIB_LDFLAGS += -shared
 
-LDFLAGS += -lpthread
+LDFLAGS += $(FAKETIME_LINK_FLAGS) -lpthread
 ifneq ($(PLATFORM),SunOS)
 LDFLAGS += -Wl,--version-script=libfaketime.map
 endif

=== debian/changelog ===
faketime (0.9.10-2.1ubuntu1) noble; urgency=medium

  * Fix faketime to stat(1) and ls(1) (LP: #2052986)
    - Take upstream commit titled 'adding support for faking statx',
      thanks to upstream contributor 'v-gb'.

 -- Dalton Durst <ubuntu-contrib@daltondur.st>  Tue, 13 Feb 2024 10:56:37 -0600

faketime (0.9.10-2.1) unstable; urgency=medium

  * Non-maintainer upload
  * test/snippets: fix time.c compiler error on 32-bit arches (Closes:
    #1010814)

 -- Paul Gevers <elbrus@debian.org>  Sat, 13 Aug 2022 20:58:42 +0200

faketime (0.9.10-2) unstable; urgency=medium

  * drop unnecessary tweak to version number
  * run extended tests during build
  * Avoid syscall-related tests (Closes: #1007828)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 16 Apr 2022 10:24:48 -0700

faketime (0.9.10-1) unstable; urgency=medium

  * new upstream release (no functional changes since previous git snapshot)
    - Closes: #939789
  * move to unstable

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 09 Mar 2022 10:47:30 -0500

faketime (0.9.9+git20220228-1) experimental; urgency=medium

  * New git snapshot release to experimental
  * fixup patch
  * drop explicit FORCE_MONOTONIC_FIX (rely on upstream autodetection)
  * Drop INTERCEPT_SYSCALL due to its instability across architectures

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 28 Feb 2022 12:51:10 -0500

faketime (0.9.9+git20211010-1) experimental; urgency=medium

  * New git snapshot release to experimental
  * drop patches already upstreamed
  * Standards-Version: bump to 4.6.0 (no changes needed)
  * d/copyright: update year ranges

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 04 Feb 2022 16:25:54 -0500

faketime (0.9.9+git20210304-2) experimental; urgency=medium

  * test variadic promotion assumptions

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 05 Mar 2021 22:54:55 -0500

faketime (0.9.9+git20210304-1) experimental; urgency=medium

  * new git snapshot release to experimental
  * refresh patches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 05 Mar 2021 21:59:11 -0500

faketime (0.9.9+git20210226-1) experimental; urgency=medium

  * new git snapshot release to experimental
  * refresh patches
  * autopkgtest: use larger-coverage snippet-driven test suite

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 25 Feb 2021 23:27:42 -0500

faketime (0.9.9+git20210225-1) experimental; urgency=medium

  * new git snapshot release to experimental
  * refresh patches
  * enable FAKE_PID
  * enable INTERCEPT_SYSCALL
  * use real_getpid instead of getpid in ft_shm_create
  * clean up test suite output
  * autopkgtests: test syscall, getpid, and randomtest features

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 25 Feb 2021 10:43:02 -0500

faketime (0.9.9+git20210223-1) experimental; urgency=medium

  * new git snapshot release to experimental
  * fix getrandom

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 23 Feb 2021 22:10:15 -0500

faketime (0.9.8+git20210209-1) experimental; urgency=medium

  * new git snapshot release to experimental
  * Update patches
  * Enable FAKE_RANDOM
  * autopkgtest: Use env var to identify the library to test

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 11 Feb 2021 18:46:44 -0500

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: faketime
 Section: utils
 Priority: optional
-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/wolfcw/libfaketime
 Vcs-Browser: https://salsa.debian.org/debian/faketime
 Vcs-Git: https://salsa.debian.org/debian/faketime.git

## faketime 0.9.10+2024-06

=== Makefile ===
--- 
+++ 
@@ -33,4 +33,23 @@
 	$(MAKE) $(SELECTOR) -C src distclean
 	$(MAKE) $(SELECTOR) -C test distclean
 
+macarm64:
+	$(MAKE) $(SELECTOR) -C src clean
+	$(MAKE) $(SELECTOR) -C src distclean
+	$(MAKE) $(SELECTOR) -C src all
+# 	$(MAKE) $(SELECTOR) -C test all
+# 	$(MAKE) $(SELECTOR) -C test distclean
+	$(MAKE) $(SELECTOR) -C src install
+	$(MAKE) $(SELECTOR) -C man install
+	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}/share/doc/faketime/"
+	$(INSTALL) -m0644 README "${DESTDIR}${PREFIX}/share/doc/faketime/README"
+	$(INSTALL) -m0644 NEWS "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"
+
+macarm64full:
+	$(MAKE) $(SELECTOR) -C src clean
+	$(MAKE) $(SELECTOR) -C src distclean
+	$(MAKE) $(SELECTOR) -C src all
+	$(MAKE) $(SELECTOR) -C test all
+# 	$(MAKE) $(SELECTOR) -C test distclean
+
 .PHONY: all test install uninstall clean distclean

=== man/Makefile ===
INSTALL ?= install

PREFIX ?= /usr/local

all:

install:
	$(INSTALL) -Dm0644 faketime.1 "${DESTDIR}${PREFIX}/share/man/man1/faketime.1"
	gzip -nf "${DESTDIR}${PREFIX}/share/man/man1/faketime.1"

uninstall:
	rm -f "${DESTDIR}${PREFIX}/share/man/man1/faketime.1.gz"

.PHONY: all install uninstall

=== src/Makefile ===
--- 
+++ 
@@ -84,6 +84,11 @@
 #         - avoid that the faketime wrapper complains when running within a
 #           libfaketime environment
 #
+#     FAIL_PRE_INIT_CALLS
+#         - If the time is queried before the library was initialised, let the
+#           call fail instead of trying to initialise on-the-fly. This fixes /
+#           works around hangs that were seen with address sanitizer.
+#
 #   * Compilation addition: second libMT target added for building the pthread-
 #     enabled library as a separate library
 #
@@ -110,20 +115,36 @@
 LIBDIRNAME ?= /lib/faketime
 PLATFORM ?=$(shell uname)
 
-CFLAGS += -std=gnu99 -Wall -Wextra -Werror -Wno-nonnull-compare -DFAKE_PTHREAD -DFAKE_STAT -DFAKE_UTIME -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"' $(FAKETIME_COMPILE_CFLAGS)
+ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang version"), 1)
+COMPILER := clang
+else
+COMPILER := gcc
+endif
+export COMPILER
+
+CFLAGS += -std=gnu99 -Wall -Wextra -Werror -DFAKE_PTHREAD -DFAKE_STAT -DFAKE_UTIME -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"' $(FAKETIME_COMPILE_CFLAGS)
+
+ifeq ($(COMPILER),clang)
+CFLAGS += -Wno-tautological-pointer-compare
+endif
+
+ifeq ($(COMPILER),gcc)
+CFLAGS += -Wno-nonnull-compare
+endif
+
 ifeq ($(PLATFORM),SunOS)
 CFLAGS += -D__EXTENSIONS__ -D_XOPEN_SOURCE=600
 endif
 
 LIB_LDFLAGS += -shared
 
-LDFLAGS += $(FAKETIME_LINK_FLAGS) -lpthread
+LDFLAGS += $(FAKETIME_LINK_FLAGS)
 ifneq ($(PLATFORM),SunOS)
 LDFLAGS += -Wl,--version-script=libfaketime.map
 endif
 
-LDADD += -ldl -lm -lrt
-BIN_LDFLAGS += -lrt
+LDADD += -ldl -lm -lrt -lpthread
+BIN_LDFLAGS += -lrt -lpthread
 
 SRC = libfaketime.c
 LIBS_OBJ = libfaketime.o libfaketimeMT.o

=== test/Makefile ===
CC = gcc

CFLAGS += -std=gnu99 -Wall -DFAKE_STAT -Werror -Wextra $(FAKETIME_COMPILE_CFLAGS)
LDFLAGS += -lrt -lpthread

SRC = timetest.c
OBJ = ${SRC:.c=.o}

TEST_SNIPPETS = $(notdir $(basename $(wildcard snippets/*.c)))
EXPECTATIONS = $(notdir $(basename $(wildcard snippets/*.variable)))

ALL_TESTS = timetest test

ifneq ($(filter -DINTERCEPT_SYSCALL,${CFLAGS}),)
ALL_TESTS += confirm_variadic_promotion
else
TEST_SNIPPETS := $(filter-out syscall%,${TEST_SNIPPETS})
EXPECTATIONS := $(filter-out syscall%,${EXPECTATIONS})
endif

all: $(ALL_TESTS)

.c.o:
	${CC} -c ${CFLAGS} $<

timetest: ${OBJ}
	${CC} -o $@ ${OBJ} ${LDFLAGS}

test: timetest functest libmallocintercept.so
	@echo
	@./test.sh

# run functional tests
functest:
	./testframe.sh functests

%_test: %_test.c
	${CC} -o $@ ${CFLAGS} $<

randomtest: repeat_random
	./randomtest.sh

libmallocintercept.so: libmallocintercept.c
	${CC} -shared -o $@ -fpic ${CFLAGS} $<

# ensure our variadic argument unpacking/repacking works as expected
confirm_variadic_promotion: variadic_promotion
	./variadic_promotion
variadic_promotion: variadic/main.o variadic/outer.o variadic/inner.o
	${CC} -o $@ ${CFLAGS} $^
variadic/%.o: variadic/%.c
	${CC} -c -o $@ ${CFLAGS} $<

# run snippet tests
snippets: test_variable_data test_library_constructors

## test snippet behavior across env var setting over time:
test_variable_data: test_variable_data.sh $(foreach f,${EXPECTATIONS},run_${f})
	./test_variable_data.sh ${EXPECTATIONS}

run_%: _run_test.c snippets/%.c
	sed s/SNIPPET_NAME/$*/g < _run_test.c | ${CC} -o $@ ${CFLAGS} -x c - 

## test snippets in other library constructors:
test_library_constructors: $(foreach f,${TEST_SNIPPETS},test_lib_${f})
test_lib_%: test_constructors.sh use_lib_% lib%.so
	./test_constructors.sh $*

lib%.so: _libtest.c snippets/%.c
	sed s/SNIPPET_NAME/$*/g < _libtest.c | ${CC} -shared -o $@ -fpic ${CFLAGS} -x c -

use_lib_%: _use_lib_test.c snippets/%.c lib%.so
	sed s/SNIPPET_NAME/$*/g < _use_lib_test.c | ${CC} -L. -o $@ ${CFLAGS} -x c - -l$*


## cleanup and metainformation

clean:
	@rm -f ${OBJ} timetest getrandom_test syscall_test $(foreach f,${TEST_SNIPPETS},use_lib_${f} lib${f}.so run_${f}) variadic_promotion variadic/*.o repeat_random libmallocintercept.so

distclean: clean
	@echo

.PHONY: all test clean distclean randomtest snippets test_variable_data test_library_constructors
